package MyTamagotchiAgentPackage;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;
import jade.core.*;

import jade.lang.acl.*;

import jade.core.behaviours.*;

/**
 * to do: description of the class for the javadoc tool.
 */

public class UserInterface extends JFrame implements ActionListener {
    public UserInterface() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private JPanel basePanel;
    private JPanel topPanel;

    private JButton button1;
    private JButton button2;
    private JButton button3;
    private JButton button4;
    private JButton button5;
    private JButton button6;
    private JButton button7;

    private TextArea messages;

    private MyTamagotchiAgent myTamagotchiAgent;

    private boolean permission = false;

    public UserInterface(MyTamagotchiAgent agent) {

        myTamagotchiAgent = agent;

        permission = false;

        this.setSize(new Dimension(500,400));
        this.setLocation(100,100);
        this.setTitle("User Interface for MyTamagotchi");

        basePanel = new JPanel(new GridLayout(3, 1));
        basePanel.setBorder(BorderFactory.createEmptyBorder(12,12,12,12));

        this.getContentPane().add(basePanel);

        topPanel = new JPanel();
        topPanel.setLayout(new BoxLayout(topPanel, BoxLayout.Y_AXIS));

        /* Add buttons corresponding to the types of action events perceived by the agent */

        button1 = new JButton("Wake Tamagotchi");
        button1.addActionListener(this);
        basePanel.add(button1);

        button2 = new JButton("I am hungry");
        button2.addActionListener(this);
        basePanel.add(button2);

        button3 = new JButton("I am sick");
        button3.addActionListener(this);
        basePanel.add(button3);

        button4 = new JButton("I am unhappy");
        button4.addActionListener(this);
        basePanel.add(button4);

        button5 = new JButton("Start feeding");
        button5.addActionListener(this);
        basePanel.add(button5);

        button6 = new JButton("Start curing");
        button6.addActionListener(this);
        basePanel.add(button6);

        button7 = new JButton("Start visiting");
        button7.addActionListener(this);
        basePanel.add(button7);

        messages = new TextArea();
        basePanel.add(messages);
    }

    public void actionPerformed(ActionEvent e) {
        Object source = e.getSource();
        if (source == button1) {
            myTamagotchiAgent.addBehaviour(new Sustain_Tamagotchi(myTamagotchiAgent, this));
            show();
        }
        else if (source == button2) {
          Behaviour b = myTamagotchiAgent.getCurrentBehaviour();
          if (permission) {
            myTamagotchiAgent.addBehaviour(new Tamagotchi_is_hungry(myTamagotchiAgent, this));
          }
        }
        else if (source == button3) {
          Behaviour b = myTamagotchiAgent.getCurrentBehaviour();
          if (permission) {
            myTamagotchiAgent.addBehaviour(new Tamagotchi_is_sick(myTamagotchiAgent, this));
          }
        }
        else if (source == button4) {
          Behaviour b = myTamagotchiAgent.getCurrentBehaviour();
           if (permission) {
            myTamagotchiAgent.addBehaviour(new Tamagotchi_is_unhappy(myTamagotchiAgent, this));
          }
       }
        else if (source == button5) {
          Behaviour b = myTamagotchiAgent.getCurrentBehaviour();
          if (permission) {
            myTamagotchiAgent.addBehaviour(new Feed_the_Tamagotchi(myTamagotchiAgent, this));
         }
       }
       else if (source == button6) {
         Behaviour b = myTamagotchiAgent.getCurrentBehaviour();
         if (permission) {
           myTamagotchiAgent.addBehaviour(new Cure_the_Tamagotchi(myTamagotchiAgent, this));
         }
       }
       else if (source == button7) {
         Behaviour b = myTamagotchiAgent.getCurrentBehaviour();
         if (permission) {
            myTamagotchiAgent.addBehaviour(new Go_to_visit_another_Tamagotchi(myTamagotchiAgent, this));
         }
       }
    }

    private void jbInit() throws Exception {
    }

    public void setPermission (boolean prm) {
      permission = prm;
    }

    public void appendMessage (String msg) {
      messages.append(msg + "\n");
    }
}
