package TamagotchiOntology;

import jade.content.onto.*;
import jade.content.schema.*;

public class TamaOntology extends Ontology {
  /** The name identifying this ontology */
  public static final String ONTOLOGY_NAME = "Tama-Ontology";

  /** VOCABULARY */

  /** Concepts */
  public static final String PRESENT = "Present";

  /** Attributes of the concept "Present" */
  public static final String PRESENT_TYPE = "presentType";

  /** The singleton instance of this ontology */
  private static Ontology theInstance = new TamaOntology();

  /** This is the method to access the singleton ontology object */
  public static Ontology getInstance() {
      return theInstance;
  }

  /** Private constructor */
  private TamaOntology() {
      /** The ontology extends the basic ontology */
      super(ONTOLOGY_NAME, BasicOntology.getInstance());

      try {
          /** Schema definitions for the "Present" concept and its internal concepts */
          add(new ConceptSchema(PRESENT), Present.class);

          /** Structure of the schema for the "Present" internal concept */
          ConceptSchema cs = (ConceptSchema) getSchema(PRESENT);
          cs.add(PRESENT_TYPE,
                 (PrimitiveSchema) getSchema(BasicOntology.STRING));
      }
      catch (OntologyException oe) {
          oe.printStackTrace();
      }
  }
}
